TrapdoorFunctionBounds Class Referenceabstract

Provides range for plaintext and ciphertext lengths. More...

`#include <pubkey.h>`

Inheritance diagram for TrapdoorFunctionBounds:

## Public Member Functions

virtual Integer | PreimageBound () const =0
| Returns the maximum size of a message before the trapdoor function is applied.
virtual Integer | ImageBound () const =0
| Returns the maximum size of a representation after the trapdoor function is applied.
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key.
virtual Integer | MaxImage () const
| Returns the maximum size of a representation after the trapdoor function is applied bound to a public key.

## Detailed Description

Provides range for plaintext and ciphertext lengths.

A trapdoor function is a function that is easy to compute in one direction, but difficult to compute in the opposite direction without special knowledge. The special knowledge is usually the private key.

Trapdoor functions only handle messages of a limited length or size. MaxPreimage is the plaintext's maximum length, and MaxImage is the ciphertext's maximum length.

See also
  TrapdoorFunctionBounds(), RandomizedTrapdoorFunction(), TrapdoorFunction(), RandomizedTrapdoorFunctionInverse() and TrapdoorFunctionInverse()

Definition at line 72 of file pubkey.h.

## Constructor & Destructor Documentation

## ~TrapdoorFunctionBounds()

virtual TrapdoorFunctionBounds::~TrapdoorFunctionBounds | ( |  | ) |

inline virtual

Definition at line 75 of file pubkey.h.

## Member Function Documentation

## PreimageBound()

virtual Integer TrapdoorFunctionBounds::PreimageBound | ( |  | ) | const

pure virtual

Returns the maximum size of a message before the trapdoor function is applied.

Returns
  the maximum size of a message before the trapdoor function is applied

Derived classes must implement PreimageBound().

Implemented in ESIGNFunction, LUCFunction, RabinFunction, RSAFunction, RSAFunction_ISO, InvertibleRSAFunction_ISO, and RWFunction.

## ImageBound()

virtual Integer TrapdoorFunctionBounds::ImageBound | ( |  | ) | const

pure virtual

Returns the maximum size of a representation after the trapdoor function is applied.

Returns
  the maximum size of a representation after the trapdoor function is applied

Derived classes must implement ImageBound().

Implemented in ESIGNFunction, LUCFunction, RabinFunction, RSAFunction, and RWFunction.

## MaxPreimage()

virtual Integer TrapdoorFunctionBounds::MaxPreimage | ( |  | ) | const

inline virtual

Returns the maximum size of a message before the trapdoor function is applied bound to a public key.

Returns
  the maximum size of a message before the trapdoor function is applied bound to a public key

The default implementation returns `PreimageBound() - 1`.

Definition at line 88 of file pubkey.h.

## MaxImage()

virtual Integer TrapdoorFunctionBounds::MaxImage | ( |  | ) | const

inline virtual

Returns the maximum size of a representation after the trapdoor function is applied bound to a public key.

Returns
  the maximum size of a representation after the trapdoor function is applied bound to a public key

The default implementation returns `ImageBound() - 1`.

Definition at line 92 of file pubkey.h.

The documentation for this class was generated from the following file:

- pubkey.h